module Bein.Web.Elements.Tags where

import Bein.Web.Elements.Base
import Text.XHtml

abbrM                :: TagM
acronymM             :: TagM
addressM             :: TagM
anchorM              :: TagM
areaM                :: ITagM
bdoM                 :: TagM
bigM                 :: TagM
blockquoteM          :: TagM
bodyM                :: TagM
boldM                :: TagM
brM                  :: ITagM
buttonM              :: TagM
captionM             :: TagM
citeM                :: TagM
colM                 :: TagM
colgroupM            :: TagM
delM                 :: TagM
ddefM                :: TagM
defineM              :: TagM
dlistM               :: TagM
dtermM               :: TagM
emphasizeM           :: TagM
fieldsetM            :: TagM
formM                :: TagM
h1M                  :: TagM
h2M                  :: TagM
h3M                  :: TagM
h4M                  :: TagM
h5M                  :: TagM
h6M                  :: TagM
headerM              :: TagM
hrM                  :: ITagM
imageM               :: ITagM
inputM               :: ITagM
insM                 :: TagM
italicsM             :: TagM
keyboardM            :: TagM
labelM               :: TagM
legendM              :: TagM
liM                  :: TagM
linkM                :: ITagM
metaM                :: ITagM
noscriptM            :: TagM
objectM              :: TagM
olistM               :: TagM
optgroupM            :: TagM
optionM              :: TagM
paragraphM           :: TagM
paramM               :: ITagM
preM                 :: TagM
quoteM               :: TagM
sampleM              :: TagM
scriptM              :: TagM
selectM              :: TagM
smallM               :: TagM
strongM              :: TagM
styleM               :: TagM
subM                 :: TagM
supM                 :: TagM
tableM               :: TagM
tbodyM               :: TagM
tdM                  :: TagM
textareaM            :: TagM
tfootM               :: TagM
thM                  :: TagM
theadM               :: TagM
thebaseM             :: ITagM
thecodeM             :: TagM
thedivM              :: TagM
thehtmlM             :: TagM
thelinkM             :: TagM
themapM              :: TagM
thespanM             :: TagM
thetitleM            :: TagM
trM                  :: TagM
ttM                  :: TagM
ulistM               :: TagM
variableM            :: TagM

abbrM = return . abbr
acronymM = return . acronym
addressM = return . address
anchorM = return . anchor
areaM = return area
bdoM = return . bdo
bigM = return . big
blockquoteM = return . blockquote
bodyM = return . body
boldM = return . bold
buttonM = return . button
brM = return br
captionM = return . caption
citeM = return . cite
colM = return . col
colgroupM = return . colgroup
ddefM = return . ddef
defineM = return . define
delM = return . del
dlistM = return . dlist
dtermM = return . dterm
emphasizeM = return . emphasize
fieldsetM = return . fieldset
formM = return . form
h1M = return . h1
h2M = return . h2
h3M = return . h3
h4M = return . h4
h5M = return . h5
h6M = return . h6
headerM = return . header
hrM = return hr
imageM = return image
inputM = return input
insM = return . ins
italicsM = return . italics
keyboardM = return . keyboard
labelM = return . label
legendM = return . legend
liM = return . li
linkM = return (itag "link")
metaM = return meta
noscriptM = return . noscript
objectM = return . object
olistM = return . olist
optgroupM = return . optgroup
optionM = return . option
paragraphM = return . paragraph
paramM = return param
preM = return . pre
quoteM = return . quote
sampleM = return . sample
scriptM = return . script
selectM = return . select
smallM = return . small
strongM = return . strong
styleM = return . style
subM = return . sub
supM = return . sup
tableM = return . table
tbodyM = return . tbody
tdM = return . td
textareaM = return . textarea
tfootM = return . tfoot
thM = return . th
theadM = return . thead
thebaseM = return thebase
thecodeM = return . thecode
thedivM = return . thediv
thehtmlM = return . thehtml
thelinkM = return . thelink
themapM = return . themap
thespanM = return . thespan
thetitleM = return . thetitle
trM = return . tr
ttM = return . tt
ulistM = return . ulist
variableM = return . variable

widgetM :: String -> String -> [HtmlAttr] -> ITagM
widgetM w n markupAttrs = inputM <!> ([thetype w] ++ ns ++ markupAttrs)
  where ns = if null n then [] else [name n,identifier n]

checkboxM :: String -> String -> Bool -> ITagM
hiddenM   :: String -> String -> ITagM
radioM    :: String -> String -> ITagM
resetM    :: String -> String -> ITagM
submitM   :: String -> String -> ITagM
passwordM :: String           -> ITagM
textfieldM :: String          -> ITagM
afileM    :: String           -> ITagM
clickmapM :: String           -> ITagM


checkboxM n v ch = widgetM "checkbox" n ([value v] ++ if ch then [checked] else [])
hiddenM   n v = widgetM "hidden"   n [value v]
radioM    n v = widgetM "radio"    n [value v]
resetM    n v = widgetM "reset"    n [value v]
submitM   n v = widgetM "submit"   n [value v]
passwordM n   = widgetM "password" n []
textfieldM n  = widgetM "text"     n []
afileM    n   = widgetM "file"     n []
clickmapM n   = widgetM "image"    n []
